#include<iostream.h>
#include<conio.h>
int prosto(int a){
  for(int i=2; i<a; i++){
    if(a%i==0) return 0;
  }
  return 1;
}
int deriv(int a){
  if(a==1||a==0) return 0;
  if(prosto(a)) return 1;
  for(int i=2; i<=a; i++){
    if(a%i==0){
      int j=a/i;
      return deriv(i)*j + deriv(j)*i;
    }
  }
}
int main(){
  int p, k;
  cin>>p>>k;
  if(p>1000||p<0||k>10||k<0){
    cout<<"error! bad input! ulialia!";
    getch(); return 0;
  }
  for(int i=0; i<k; i++){
    p=deriv(p);
  }
  cout<<p<<endl;
  getch(); return 0;
}